#include <stdio.h>
#include <stdlib.h>

#include "memmap.h"
#include "memlock.h"

#ifdef _WIN32
#include <windows.h>

void sleep( int x) { Sleep( 1000*x); }
void usleep( int x) { Sleep( x/1000); }
#endif

/* get integer random number in range a <= x <= e */
int irand( int a, int e)
{
    double r = e - a + 1;
    return a + (int)(r * rand()/(RAND_MAX+1.0));
}

int main( int argc, char **argv)
{
    int rc, i, sum;
    int *a;
    mappedRegion reg;
    MEMLOCK s;

    rc = memmap( "xxxmapfilexxx", 12345, 200*sizeof(int), &reg);
    if (rc != 0) {
        printf( "memmap failed, rc = %d\n", rc);
        exit(1);
    }
    a = (int *)memGetAddr( &reg);
    if (200 > memGetLength( &reg)) {
        printf( "mapped region too small\n");
        exit(1);
    }

    if ( memLockCreate( 12345, & s) < 0) {
        printf( "memLockCreate failed\n");
        exit(1);
    }

    srand( time(0));
    for (;;) {
        memLock(s);
        a[irand(0,198)] = irand(-1000, 1000);
        /* compute sum and put it into a[199] */
        for (i=0, sum=0; i<199; ++i) {
            usleep( 10000); /* to increase the likelyhood of the problem */
            sum += a[i];
        }
        a[199] = sum;
        memUnlock(s);

        sleep(1);
    }
    memLockDestroy(s);
}
